import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;

public class BarrierTask implements Runnable {
	final CyclicBarrier barrier;
	final int id;
	
	BarrierTask(CyclicBarrier barrier, int id) {
		super();
		this.barrier=barrier;
		this.id=id;
	}
	
	public void run() {
		try {
			System.out.println("Task "+id+" waiting at barrier.");
			barrier.await(); 
			System.out.println("Task "+id+" released by barrier.");
		} catch (InterruptedException e) {
			e.printStackTrace();
		} catch (BrokenBarrierException e) {
			e.printStackTrace();
		}
	}
	
}

