import java.util.concurrent.locks.Condition;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReentrantLock;

public class ConditionLockExample {
	private Lock lock = new ReentrantLock();
	private Condition zero = lock.newCondition();
	private Condition max = lock.newCondition();
	private int value = 0;
	private final int MAX = 5;
	private final int MIN = 0;
	
	public void increment ( ) {
		lock.lock();
		try {
			while (value >= MAX) {
				zero.await();
			}
			value++;
			max.signal();
			System.out.println("Value incremented to " + value);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} finally {
			lock.unlock();
		}
	}

	public void decrement ( ) {
		lock.lock();
		try {
			while (value <= MIN) {
				max.await();
			}
			value--;
			zero.signal();
			System.out.println("Value decremented to " + value);
		} catch (InterruptedException e) {
			e.printStackTrace();
		} finally {
			lock.unlock();
		}
	}
}
