import java.util.concurrent.ThreadFactory;

public class ThreadFactoryExample implements ThreadFactory {
	private static int id = 0;
	
	public Thread newThread(Runnable r, String name, int priority) {
		Thread t = new Thread(r);
		if (priority>Thread.MAX_PRIORITY) {
			priority=Thread.MAX_PRIORITY;
		} else if (priority<Thread.MIN_PRIORITY) {
			priority=Thread.MIN_PRIORITY;
		}
		t.setPriority(priority);
		t.setName(name);
		return t;
	}

	public Thread newThread(Runnable r) {
		return this.newThread(r, "Task "+id++,Thread.NORM_PRIORITY);
	}

}
